#!/bin/sh
# This program is licensed under the GNU GPL version 2 or later.
-# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
+# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2014
# For details, see LICENSE. To submit patches, you have to agree to
# license your code under the GNU GPL version 2 or later.
+# While the following is not legally binding, the author would like to
+# explain the choice of GPLv2+ over GPLv3+.
+# The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
+# full compatibility's with Git. In case Git ever changes its licensing terms,
+# which is admittedly extremely unlikely to the point of being impossible,
+# this software will most likely follow suit.
+# This should always be the first line of code to facilitate debugging
+[ -n "$VCSH_DEBUG" ] && set -vx
+
+
+# If '.git-HEAD' is appended to the version, you are seeing an unreleased
+# version of vcsh; the master branch is supposed to be clean at all times
+# so you can most likely just use it nonetheless
+VERSION='1.20141009'
+SELF=$(basename $0)
+
+fatal() {
+ echo "$SELF: fatal: $1" >&2
+ [ -z $2] && exit 1
+ exit $2
+}
+
+# We need to run getops as soon as possible so we catch -d and other
+# options that will modify our behaviour.
+# Commands are handled at the end of this script.
+while getopts "c:dv" flag; do
+ if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
+ set -vx
+ VCSH_DEBUG=1
+ echo "debug mode on"
+ echo "$SELF $VERSION"
+ elif [ x"$1" = x'-v' ]; then
+ VCSH_VERBOSE=1
+ echo "verbose mode on"
+ echo "$SELF $VERSION"
+ elif [ x"$1" = x'-c' ]; then
+ VCSH_OPTION_CONFIG=$OPTARG
+ fi
+ shift 1
+done
+
+source_all() {
+ # Source file even if it's in $PWD and does not have any slashes in it
+ case $1 in
+ */*) . "$1";;
+ *) . "$PWD/$1";;
+ esac;
+}
+
+
+# Read configuration and set defaults if anything's not set
[ -n "$VCSH_DEBUG" ] && set -vx
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+: ${XDG_CONFIG_HOME:="$HOME/.config"}
+
+# Read configuration files if there are any
+[ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+if [ -n "$VCSH_OPTION_CONFIG" ]; then
+ # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
+ if [ -r "$VCSH_OPTION_CONFIG" ]; then
+ source_all "$VCSH_OPTION_CONFIG"
+ else
+ fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
+ fi
+fi
[ -n "$VCSH_DEBUG" ] && set -vx
-[ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
-[ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
-[ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
-[ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
-SELF=$(basename $0)
+# Read defaults
+: ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
+: ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
+: ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
+: ${VCSH_BASE:="$HOME"}
+: ${VCSH_GITIGNORE:=exact}
+: ${VCSH_GITATTRIBUTES:=none}
+: ${VCSH_WORKTREE:=absolute}
+
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+ fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
+fi
+
+if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
+ fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
+fi
+
help() {
- echo "usage: $SELF <args>
+ echo "usage: $SELF <options> <command>
+
+ options:
+ -c <file> Source file
+ -d Enable debug mode
+ -v Enable verbose mode
+ commands:
clone <remote> \\
[<repo>] Clone from an existing repository
+ commit Commit in all repositories
+ delete <repo> Delete an existing repository
+ enter <repo> Enter repository; spawn new instance of \$SHELL
help Display this help text
- delete Delete an existing repository
- enter Enter repository; spawn new instance of \$SHELL
init <repo> Initialize a new repository
list List all repositories
list-tracked List all files tracked by vcsh
list-tracked-by \\
<repo> List files tracked by a repository
+ pull Pull from all vcsh remotes
+ push Push to vcsh remotes
rename <repo> \\
<newname> Rename repository
run <repo> \\
<command> Use this repository
- setup Set up repository with recommended settings
+ status [<repo>] Show statuses of all/one vcsh repositories
+ upgrade <repo> Upgrade repository to currently recommended settings
+ version Print version information
which <substring> Find substring in name of any tracked file
write-gitignore \\
<repo> Write .gitignore.d/<repo> via git ls-files
if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
}
-fatal() {
- echo "$SELF: fatal: $1" >&2
- exit $2
-}
-
error() {
echo "$SELF: error: $1" >&2
}
}
clone() {
+ hook pre-clone
init
git remote add origin "$GIT_REMOTE"
git config branch.master.remote origin
git config branch.master.merge refs/heads/master
- if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
- info "remote is empty, not merging anything"
- exit
+ VCSH_CLONE_ERROR=$(git ls-remote origin master 2>&1)
+ if [ -n "$VCSH_CLONE_ERROR" ]; then
+ rm -rf "$GIT_DIR"
+ fatal "$VCSH_CLONE_ERROR" 1
fi
git fetch
- for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+ hook pre-merge
+ git ls-tree -r --name-only origin/master | (while read object; do
[ -e "$object" ] &&
error "'$object' exists." &&
- VCSH_CONFLICT=1;
+ VCSH_CONFLICT=1
done
- [ "$VCSH_CONFLICT" = '1' ] &&
+ [ x"$VCSH_CONFLICT" = x'1' ]) &&
fatal "will stop after fetching and not try to merge!
- Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
+ Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
git merge origin/master
+ hook post-merge
+ hook post-clone
+ retire
+ hook post-clone-retired
+}
+
+commit() {
+ hook pre-commit
+ for VCSH_REPO_NAME in $(list); do
+ echo "$VCSH_REPO_NAME: "
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ git commit --untracked-files=no --quiet
+ VCSH_COMMAND_RETURN_CODE=$?
+ echo
+ done
+ hook post-commit
}
delete() {
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
use
- info "This operation WILL DETROY DATA!"
+ info "This operation WILL DESTROY DATA!"
files=$(git ls-files)
echo "These files will be deleted:
for file in $files; do
rm -f $file || info "could not delete '$file', continuing with deletion"
done
- rmdir "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+ rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
}
enter() {
}
hook() {
- for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+ for hook in "$VCSH_HOOK_D/$1"* "$VCSH_HOOK_D/$VCSH_REPO_NAME.$1"*; do
[ -x "$hook" ] || continue
- info "executing '$hook'"
+ verbose "executing '$hook'"
"$hook"
done
}
init() {
+ hook pre-init
[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
- export GIT_WORK_TREE="$VCSH_BASE"
- mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
- cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
- git init
- setup
+ mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
+ cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+ git init --shared=0600
+ upgrade
+ hook post-init
}
list() {
- for i in "$VCSH_REPO_D"/*.git; do
- echo $(basename "$i" .git)
+ for repo in "$VCSH_REPO_D"/*.git; do
+ [ -d "$repo" ] && [ -r "$repo" ] && echo "$(basename "$repo" .git)"
done
}
get_files() {
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
git ls-files
}
list_tracked() {
for VCSH_REPO_NAME in $(list); do
get_files
- done | sort -u
+ done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
+ sed 's/[,\&]/\\&/g')," | sort -u
}
list_tracked_by() {
use
- git ls-files | sort -u
+ git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
+ sed 's/[,\&]/\\&/g')," | sort -u
+}
+
+pull() {
+ hook pre-pull
+ for VCSH_REPO_NAME in $(list); do
+ printf '%s: ' "$VCSH_REPO_NAME"
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ git pull
+ VCSH_COMMAND_RETURN_CODE=$?
+ echo
+ done
+ hook post-pull
+}
+
+push() {
+ hook pre-push
+ for VCSH_REPO_NAME in $(list); do
+ printf '%s: ' "$VCSH_REPO_NAME"
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ git push
+ VCSH_COMMAND_RETURN_CODE=$?
+ echo
+ done
+ hook post-push
+}
+
+retire() {
+ unset VCSH_DIRECTORY
}
rename() {
[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+ # Now that the repository has been renamed, we need to fix up its configuration
+ # Overwrite old name..
+ GIT_DIR=$GIT_DIR_NEW
+ VCSH_REPO_NAME=$VCSH_REPO_NAME_NEW
+ # ..and clobber all old configuration
+ upgrade
}
run() {
hook pre-run
use
- $VCSH_EXTERNAL_COMMAND
+ "$@"
+ VCSH_COMMAND_RETURN_CODE=$?
hook post-run
}
-setup() {
- hook pre-setup
+status() {
+ if [ -n "$VCSH_REPO_NAME" ]; then
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ git status --short --untracked-files='no'
+ VCSH_COMMAND_RETURN_CODE=$?
+ else
+ for VCSH_REPO_NAME in $(list); do
+ echo "$VCSH_REPO_NAME:"
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ git status --short --untracked-files='no'
+ VCSH_COMMAND_RETURN_CODE=$?
+ echo
+ done
+ fi
+}
+
+upgrade() {
+ hook pre-upgrade
+ # fake-bare repositories are not bare, actually. Set this to false
+ # because otherwise Git complains "fatal: core.bare and core.worktree
+ # do not make sense"
+ git config core.bare false
+ # core.worktree may be absolute or relative to $GIT_DIR, depending on
+ # user preference
+ if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
+ git config core.worktree "$(cd "$GIT_DIR" && GIT_WORK_TREE=$VCSH_BASE git rev-parse --show-cdup)"
+ elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
+ git config core.worktree "$VCSH_BASE"
+ fi
+ [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+ [ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && git config core.attributesfile ".gitattributes.d/$VCSH_REPO_NAME"
+ git config vcsh.vcsh 'true'
use
- git config core.worktree "$GIT_WORK_TREE"
- git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
- git config vcsh.vcsh 'true'
[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
- hook post-setup
+ [ -e "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitattributes.d/$VCSH_REPO_NAME"
+ hook post-upgrade
}
use() {
git_dir_exists
- export GIT_WORK_TREE="$(git config --get core.worktree)"
- export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+ VCSH_DIRECTORY=$VCSH_REPO_NAME; export VCSH_DIRECTORY
}
which() {
+ [ -e "$VCSH_COMMAND_PARAMETER" ] || fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
for VCSH_REPO_NAME in $(list); do
for VCSH_FILE in $(get_files); do
- echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
+ echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
done
done | sort -u
}
write_gitignore() {
+ # Don't do anything if the user does not want to write gitignore
+ if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
+ info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
+ exit
+ fi
+
use
cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+ OLDIFS=$IFS
+ IFS=$(printf '\n\t')
gitignores=$(for file in $(git ls-files); do
while true; do
- echo $file; new="${file%/*}"
- [ "$file" = "$new" ] && break
- file="$new"
+ echo "$file"; new=${file%/*}
+ [ x"$file" = x"$new" ] && break
+ file=$new
done;
done | sort -u)
- tempfile=$(mktemp) || fatal "could not create tempfile" 51
+
+ # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
+ # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
+ # To make every OS happy, set full path explicitly
+ tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
+
echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
for gitignore in $gitignores; do
- echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
- if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
- { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+ echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+ if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
+ { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
fi
done
+ IFS=$OLDIFS
if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
rm -f "$tempfile" || error "could not delete '$tempfile'"
exit
fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
}
-if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
- fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
+debug $(git version)
+
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+ fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
fi
-if [ "$1" = 'clone' ]; then
- [ -z $2 ] && fatal "$1: please specify a remote" 1
- export VCSH_COMMAND="$1"
+VCSH_COMMAND=$1; export VCSH_COMMAND
+
+case $VCSH_COMMAND in
+ clon|clo|cl) VCSH_COMMAND=clone;;
+ commi|comm|com|co) VCSH_COMMAND=commit;;
+ delet|dele|del|de) VCSH_COMMAND=delete;;
+ ente|ent|en) VCSH_COMMAND=enter;;
+ hel|he) VCSH_COMMAND=help;;
+ ini|in) VCSH_COMMAND=init;;
+ pul) VCSH_COMMAND=pull;;
+ pus) VCSH_COMMAND=push;;
+ renam|rena|ren|re) VCSH_COMMAND=rename;;
+ ru) VCSH_COMMAND=run;;
+ statu|stat|sta|st) VCSH_COMMAND=status;;
+ upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
+ versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
+ which|whi|wh) VCSH_COMMAND=which;;
+ write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
+esac
+
+if [ x"$VCSH_COMMAND" = x'clone' ]; then
+ [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
GIT_REMOTE="$2"
- [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+ [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+ [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
export VCSH_REPO_NAME
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'which' ]; then
- [ -z "$2" ] && fatal "$1: please specify a filename" 1
- [ -n "$3" ] && fatal "$1: too many parameters" 1
- export VCSH_COMMAND="$1"
- export VCSH_COMMAND_PARAMETER="$2"
-elif [ "$1" = 'delete' ] ||
- [ "$1" = 'enter' ] ||
- [ "$1" = 'init' ] ||
- [ "$1" = 'list-tracked-by' ] ||
- [ "$1" = 'rename' ] ||
- [ "$1" = 'run' ] ||
- [ "$1" = 'setup' ] ||
- [ "$1" = 'write-gitignore' ]; then
- [ -z $2 ] && fatal "$1: please specify repository to work on" 1
- [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
- [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
- export VCSH_COMMAND="$1"
- export VCSH_REPO_NAME="$2"
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
- [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
- [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
- [ "$VCSH_COMMAND" = 'write-gitignore' ]
-elif [ "$1" = 'list' ] ||
- [ "$1" = 'list-tracked' ]; then
- export VCSH_COMMAND="$1"
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+elif [ "$VCSH_COMMAND" = 'version' ]; then
+ echo "$SELF $VERSION"
+ git version
+ exit
+elif [ x"$VCSH_COMMAND" = x'which' ]; then
+ [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
+ [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
+ VCSH_COMMAND_PARAMETER=$2; export VCSH_COMMAND_PARAMETER
+elif [ x"$VCSH_COMMAND" = x'delete' ] ||
+ [ x"$VCSH_COMMAND" = x'enter' ] ||
+ [ x"$VCSH_COMMAND" = x'init' ] ||
+ [ x"$VCSH_COMMAND" = x'list-tracked-by' ] ||
+ [ x"$VCSH_COMMAND" = x'rename' ] ||
+ [ x"$VCSH_COMMAND" = x'run' ] ||
+ [ x"$VCSH_COMMAND" = x'upgrade' ] ||
+ [ x"$VCSH_COMMAND" = x'write-gitignore' ]; then
+ [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
+ [ x"$VCSH_COMMAND" = x'rename' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
+ [ x"$VCSH_COMMAND" = x'run' ] && [ -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
+ VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ [ x"$VCSH_COMMAND" = x'rename' ] && { VCSH_REPO_NAME_NEW=$3; export VCSH_REPO_NAME_NEW;
+ GIT_DIR_NEW=$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git; export GIT_DIR_NEW; }
+ [ x"$VCSH_COMMAND" = x'run' ] && shift 2
+elif [ x"$VCSH_COMMAND" = x'commit' ] ||
+ [ x"$VCSH_COMMAND" = x'list' ] ||
+ [ x"$VCSH_COMMAND" = x'list-tracked' ] ||
+ [ x"$VCSH_COMMAND" = x'pull' ] ||
+ [ x"$VCSH_COMMAND" = x'push' ]; then
+ :
+elif [ x"$VCSH_COMMAND" = x'status' ]; then
+ VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
elif [ -n "$2" ]; then
- export VCSH_COMMAND='run'
- export VCSH_REPO_NAME="$1"
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
- [ -d $GIT_DIR ] || { help; exit 1; }
+ VCSH_COMMAND='run'; export VCSH_COMMAND
+ VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ [ -d "$GIT_DIR" ] || { help; exit 1; }
shift 1
- export VCSH_EXTERNAL_COMMAND="git $*"
-elif [ -n "$1" ]; then
- export VCSH_COMMAND='enter'
- export VCSH_REPO_NAME="$1"
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
- [ -d $GIT_DIR ] || { help; exit 1; }
+ set -- "git" "$@"
+elif [ -n "$VCSH_COMMAND" ]; then
+ VCSH_COMMAND='enter'; export VCSH_COMMAND
+ VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ [ -d "$GIT_DIR" ] || { help; exit 1; }
else
# $1 is empty, or 'help'
help && exit
# Did we receive a directory instead of a name?
# Mangle the input to fit normal operation.
-if echo $VCSH_REPO_NAME | grep -q '/'; then
- export GIT_DIR=$VCSH_REPO_NAME
- export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
+if echo "$VCSH_REPO_NAME" | grep -q '/'; then
+ GIT_DIR=$VCSH_REPO_NAME; export GIT_DIR
+ VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git); export VCSH_REPO_NAME
fi
-
-for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
-do
+check_dir() {
+ check_directory="$1"
if [ ! -d "$check_directory" ]; then
if [ -e "$check_directory" ]; then
fatal "'$check_directory' exists but is not a directory" 13
else
- info "attempting to create '$check_directory'"
+ verbose "attempting to create '$check_directory'"
mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
fi
fi
-done
+}
+
+check_dir "$VCSH_REPO_D"
+[ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
+[ ! "x$VCSH_GITATTRIBUTES" = 'xnone' ] && check_dir "$VCSH_BASE/.gitattributes.d"
verbose "$VCSH_COMMAND begin"
-export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
-$VCSH_COMMAND
+VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
+
+# source overlay functions
+for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
+ [ -r "$overlay" ] || continue
+ info "sourcing '$overlay'"
+ . "$overlay"
+done
+
+hook pre-command
+$VCSH_COMMAND "$@"
+hook post-command
verbose "$VCSH_COMMAND end, exiting"
+exit $VCSH_COMMAND_RETURN_CODE